#ifndef _QTRANSFORMMATRIXWIDGET_H_
#define _QTRANSFORMMATRIXWIDGET_H_

#include <QtGui>

#include "math/TransformMatrix.h"

#include "ui_qtransformmatrixwidget.h"

namespace projection
{

class QTransformMatrixWidget : public QWidget
{
    Q_OBJECT

public:

    QTransformMatrixWidget(QWidget* pParent=0, Qt::WFlags flag=0);
    ~QTransformMatrixWidget();

    void setMatrix(const TransformMatrix& matrix);
    TransformMatrix getMatrix() const;

    void setUseScale(bool bUseScale);

    void clear();

signals:

    void matrixChanged(const TransformMatrix& matrix);

private slots:

    void on_posXEdit_editingFinished();
    void on_posYEdit_editingFinished();
    void on_posZEdit_editingFinished();
    void on_rotHEdit_editingFinished();
    void on_rotPEdit_editingFinished();
    void on_rotREdit_editingFinished();
    void on_scaleXEdit_editingFinished();
    void on_scaleYEdit_editingFinished();
    void on_scaleZEdit_editingFinished();

    void checkValueChanged();

private:

    Ui::QTransformMatrixWidget ui;

    TransformMatrix m_matrix;
    bool m_bStopSlot;               //??
};

}; // projection

#endif // _QTRANSFORMMATRIXWIDGET_H_
